// Copyright 2019 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// See iree/base/api.h for documentation on the API conventions used.

#ifndef IREE_HAL_API_H_
#define IREE_HAL_API_H_

#include "iree/hal/allocator.h"              // IWYU pragma: export
#include "iree/hal/buffer.h"                 // IWYU pragma: export
#include "iree/hal/buffer_view.h"            // IWYU pragma: export
#include "iree/hal/command_buffer.h"         // IWYU pragma: export
#include "iree/hal/descriptor_set.h"         // IWYU pragma: export
#include "iree/hal/descriptor_set_layout.h"  // IWYU pragma: export
#include "iree/hal/device.h"                 // IWYU pragma: export
#include "iree/hal/driver.h"                 // IWYU pragma: export
#include "iree/hal/driver_registry.h"        // IWYU pragma: export
#include "iree/hal/event.h"                  // IWYU pragma: export
#include "iree/hal/executable.h"             // IWYU pragma: export
#include "iree/hal/executable_cache.h"       // IWYU pragma: export
#include "iree/hal/executable_layout.h"      // IWYU pragma: export
#include "iree/hal/semaphore.h"              // IWYU pragma: export
#include "iree/hal/string_util.h"            // IWYU pragma: export

#endif  // IREE_HAL_API_H_
